/**
 *
 *   9      
 *   4017. 
 * 
 * ,     20,
 *    1  2 .   10 ,
 *   9 -     
 *  ,    20.
 *
 *  ATMega16(32)    16 .  
 *    A.
 *
 *  16- ,     
 *   8,    0,5 .    
 *        OC1A.
 *       (  
 *   OCR1B),          18.
 * 
 *    (8)    8- .
 *
 **/

#include <avr/io.h>
#include <avr/interrupt.h>


/**
 * ,    .    
 *   500,       
 *   ,   2. 3000   ,
 * 2000  4000  .
 **/
uint16_t servo_position[9] = {2000, 2200, 2400, 2600, 2800, 3000, 3200, 3412 , 3600};

volatile uint32_t i;

/**
 *   
 **/

SIGNAL(SIG_OUTPUT_COMPARE1A)
{
	/*  ,    .
	 * ,     ,   1,    
	 *    ,   
	 *   1.
	 */
	static uint8_t current_servo = 1;
	/**
	 * ,     ,  , 
	 *     9  18 .    
	 * 20,   pause.   40000, 
	 *  20.    , 
	 *     ,   
	 *      ,    20 
	 */
	static uint16_t pause = 40000;

	/*      OCR1A,  ,  
	 *    OC1A  0  1,    
	 *     .    
	 *     ,    OCR1A
	 */
	TCCR1A |= _BV(FOC1A);

	if (current_servo == 9) {
		/*  current_servo  9 -    , 
		 *      20  */
		current_servo = 0;
		OCR1A += pause;
		pause = 40000;
	} else {
		/* current_servo  0  7 -    
		 *  ,   . */
		OCR1A += servo_position[current_servo];
		/*    */
		pause -= servo_position[current_servo];
		/*     */
		current_servo++;
	}
}

int main(void)
{
	/*        */
	DDRD = 0x60;

	/*      */
	PORTD |= 0x40;
	/*       */
	OCR1A = 2000;

	/*       0  0xFFFF.   
	 *   OCR1A   OC1A   . */
	TCCR1A = _BV(COM1A0);
	/*    = 8 */
	TCCR1B = _BV(CS11);
	/*       OCR1A */
	TIMSK = _BV(OCIE1A);

	/*      */
	PORTD &= ~0x40;
	sei();					/*   */

	for(;;)  {
		i++;
	}
}
